#include "big5.hh"

const wstring big5::c2uni(const string &s, bool html)
{
    wstring ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        wchar_t t;
        if(cache)
        {
            t = 256*cache + (unsigned char)s[a];
            
            charmap::const_iterator i = in->find(t);
            if(i == in->end())
            {
                ss += cache;
                ss += (unsigned char)s[a];
            }
            else
                ss += i->second;
            cache = 0;
        }
        else
        {
            if(html)
            {
                ss += TryParseEntities(s, a);
                if(a==b)break;
            }
            cache = (unsigned char)s[a];
            
            /* Big5 are A140 .. F9D5 */                
            if(cache<0xA1 || cache>0xF9)
            {
                cache = 0;
                ss += cache;
            }
        }
    }
    return ss;
}

const string big5::uni2c(const wstring &s)
{
    string ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        charmap::const_iterator i = out->find(s[a]);
        if(i == out->end())
        {
            if((s[a] >= 0xA1 && s[a] <= 0xF9) || s[a] >= 0x100)
                ss += '?';
            else
                ss += (char)s[a];
        }
        else
        {
            ss += (char)(i->second >> 8);
            ss += (char)(i->second & 255);
        }
    }
    return ss;
}
