#include "charsets.hh"

converter::converter(const string &inputmime, const string &outputmime)
{
    in = newconverter(inputmime);
    out = newconverter(outputmime);
}
converter::~converter()
{
    delete in;
    delete out;
}

const wstring converter::html2wstring(const string &s)
{
    return in->c2uni(s, true);
}

const string converter::wide2str(const wstring &s)
{
    return out->uni2c(s);
}

void converter::setinputtype(const string &mime)
{
    delete in;
    in = newconverter(mime);
}

void converter::setmodifytype(const string &mime)
{
    delete out;
    out = newconverter(mime);
}

charmap::charmap()
{
}

charmap::~charmap()
{
}

const charmap::const_iterator charmap::find(unsigned what) const
{
    const_iterator result;
    if(size())
    {
        unsigned eka=0, vika=size()-1;
        for(;;)
        {
            unsigned n = (eka+vika)/2;
            unsigned key = getkey(n);
            if(what == key)
            {
                result.set(what, getvalue(n));
                break;
            }
            if(eka >= vika)break;
            if(what > key) { eka=n+1; continue; }
            if(what < key) { vika=n; continue; }
        }
    }
    return result;
}
