#include "easycharset.hh"
#include "charsets.hh"

const wstring easycharset::c2uni(const string &s, bool html=false)
{
    wstring ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        if(html)
        {
            ss += TryParseEntities(s, a);
            if(a==b)break;
        }
        charmap::const_iterator i = in->find((unsigned char)s[a]);
        if(i == in->end())
            ss += 0xFFFD; /* undefined char */
        else
            ss += i->second;
    }
    return ss;
}

const string easycharset::uni2c(const wstring &s)
{
    string ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        charmap::const_iterator i = out->find(s[a]);
        if(i == out->end())
            ss += '?';
        else
            ss += (char)i->second;
    }
    return ss;
}
