#ifndef bqt_utf7_hh
#define bqt_utf7_hh

#include "charsets.hh"

class utf7 : public charset
{
    bool inside;
    unsigned cache, cachelen;
    bool modified, had;
    const char startchar() const { return modified ? '&' : '+'; }
    const char endchar() const   { return '-'; }
    const bool mustencode(unsigned c) const;
    const char base64(unsigned n) const; /* n=0..63 */
    const unsigned esab64(char n) const; /* return=0..64 (64=invalid) */
public:
    utf7(bool modi) : inside(false), modified(modi) { }
    virtual const wstring c2uni(const string &s, bool html=false);
    virtual const string uni2c(const wstring &s);
};

#endif
