#include "utf8.hh"

const wstring utf8::c2uni(const string &s, bool html)
{
    wstring ss;
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        unsigned char c = s[a];
        if(bytesleft > 0) { --bytesleft; cache = cache * 64 + (c&63); }
        else
        {
        Redo:
            if((c & 0xE0) == 0xC0) { bytesleft=1; cache = c&0x1F; }
            else if((c & 0xF0) == 0xE0) { bytesleft=2; cache = c&0x0F; }
            else if((c & 0xF8) == 0xF0) { bytesleft=3; cache = c&0x07; }
            else
            {
                if(html)
                {
                    ss += TryParseEntities(s, a);
                    if(a==b)break;
                    c = s[a];
                    if(c&0x80)goto Redo;
                }
                cache = c&0x7F;
            }
        }
        if(!bytesleft)
        {
            ss += (wchar_t)cache;
        }
    }
    return ss;
}

const string utf8::uni2c(const wstring &s)
{
    string ss;
    if(islinux)ss = "\33%G"; /* Starts UTF-8 in Linux */
    unsigned a, b=s.size();
    for(a=0; a<b; ++a)
    {
        wchar_t c = s[a];
        if(c < 0x80)
            ss += (unsigned char)c;
        else if(c < 0x800)
        {
            ss += (unsigned char)(0xC0 + (c>>6));
            ss += (unsigned char)(0x80 + (c&63));
        }
        else if(c < 0x10000)
        {
            ss += (unsigned char)(0xE0 + (c>>12));
            ss += (unsigned char)(0x80 + ((c>>6)&63));
            ss += (unsigned char)(0x80 + (c&63));
        }
        else
        {
            ss += (unsigned char)(0xE0 + (c>>18));
            ss += (unsigned char)(0x80 + ((c>>12)&63));
            ss += (unsigned char)(0x80 + ((c>>6)&63));
            ss += (unsigned char)(0x80 + (c&63));
        }
    }
    if(islinux)ss += "\33%@";     /* Ends UTF-8 in Linux */
    return ss;
}
